<?php

session_start();
ob_start();
$do = isset($_GET['do']) ? $_GET['do'] : "";
$ajaxDoArr = array("add2SimpleReturn");
include("initiateStaticSessionCommingWithCurl.php");
if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
    array_push($ajaxDoArr, $do);
}

if (!in_array($do, $ajaxDoArr)) {
    include("../public/impOpreation.php");
}



include_once("../public/config.php");
include("../library/newUplode/uploadfunctions.php");


require_once('../models/dao/YoutubeLinkDAO.class.php');
require_once('../models/dto/YoutubeLink.class.php');
require_once('../models/mysql/YoutubeLinkMySqlDAO.class.php');
require_once('../models/mysql/ext/YoutubeLinkMySqlExtDAO.class.php');




//get the do the action
$do = $_GET['do'];

$langs = $_SESSION['erp_lang'];
include_once("../views/languages/$langs/success.php");
include_once("../views/languages/$langs/error.php");


if (!in_array($do, $ajaxDoArr)) {
    if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {

    } else {
        $smarty->display("header.html");
    }
}



$youtubeLink = new YoutubeLink();
$youtubeLinkDAO = new YoutubeLinkMySqlDAO();
$youtubeLinkEX = new YoutubeLinkMySqlExtDAO();

$today = date("Y-m-d");

//check and use the condition that suite this action
if (empty($do)) {
    //here the permission check
  
    $sql="SELECT * FROM user WHERE userid != -1";
    $employees = R::getAll($sql);
     $smarty->assign('employees', $employees);
    $smarty->display("messagesview/add.html");
} elseif ($do == "add") {
    try { 
    
        add();
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 1, 'message' => 'تمت العمليه بنجاح', 'message_en' => 'Success');
            echo json_encode($data);
        } else {
            header("location:?do=sucess");
        }
    } catch (Exception $e) {
        echo $e;
        die();
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 2, 'message' => 'حدث خطأ', 'message_en' => 'Error');
            echo json_encode($data);
        } else {
            header("location:?do=error");
        }
    }
} elseif ($do == "show") {
    $current_user_id = $_SESSION['userid'];
  if ($current_user_id == 1) {
    $sql = "SELECT m.*, u.employeename 
            FROM messages m
            LEFT JOIN user u ON m.userid = u.userid
            WHERE m.isdel = 0 
            ORDER BY m.id DESC";
    $showData = R::getAll($sql); 
} else {
    $sql = "SELECT m.*, u.employeename 
            FROM messages m
            LEFT JOIN user u ON m.userid = u.userid
            WHERE m.isdel = 0 
            AND m.userid = ? 
            ORDER BY m.id DESC";
            
    $showData = R::getAll($sql, [$current_user_id]);
}
   
    
    $smarty->assign('showData', $showData);

    $youtubes = $youtubeLinkDAO->queryAll();
    $smarty->assign("youtubes", $youtubes);

    $smarty->display("messagesview/show.html");
    $smarty->assign("customCheck", 1);
} elseif ($do == "deleteFinaly") {
    try {
        $id = (int) $_GET['id'];
        deleteFinaly($id);

        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 1, 'message' => 'تمت العمليه بنجاح', 'message_en' => 'Success');
            echo json_encode($data);
        } else {
            header("location:?do=sucess");
        }
    } catch (Exception $e) {
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 2, 'message' => 'حدث خطأ', 'message_en' => 'Error');
            echo json_encode($data);
        } else {
            header("location:?do=error");
        }
    }
} elseif ($do == "edit") { //edit request
    $id = $_GET['id'];
     $sql="SELECT * FROM user ";
    $employees = R::getAll($sql);
     $smarty->assign('employees', $employees);
    $showData = R::load('messages', $id);
    
    $smarty->assign('showData', $showData);

    $smarty->display("messagesview/edit.html");
} elseif ($do == "update") { //edit update
    try {
        update();
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 1, 'message' => 'تمت العمليه بنجاح', 'message_en' => 'Success');
            echo json_encode($data);
        } else {
            header("location:?do=sucess");
        }
    } catch (Exception $e) {
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 2, 'message' => 'حدث خطأ', 'message_en' => 'Error');
            echo json_encode($data);
        } else {
            header("location:?do=error");
        }
    }
} elseif ($do == "sucess") {
    //here the smarty templates
    $smarty->display("succes.html");
} elseif ($do == "error") {
    //here the smarty templates
    $smarty->display("error.html");
}


$smarty->assign("customValidation", 1);

//here the global templates
if (!in_array($do, $ajaxDoArr)) {
    if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {

    } else {
        $smarty->display("footer.html");
    }
}

/* ===============================
  function in this CONTROLLER
  ================================ */

// add in tenderannouncement tbl
function add() {
   
    $subject = $_POST['subject'];
    $details = $_POST['details'];
     $employee = "";
   if (isset($_POST['employee']) && is_array($_POST['employee'])) {
    
    $employee = implode(',', array_unique(array_filter($_POST['employee'])));
} else {
    $employee = $_POST['employee'];
}
    $target_dir = "../upload/messages/";

    if (!file_exists($target_dir)) {
        mkdir($target_dir, 0777, true);
    }
    $rdispense = R::dispense('messages');
    $rdispense->employee = $employee;
    $rdispense->subject = $subject;
    $rdispense->details = $details;
        $images = [];
    foreach ($_FILES['image']['name'] as $key => $val) {
        if ($_FILES['image']['tmp_name'][$key] != "") {
            $imgname = time() . "_" . $_FILES['image']['name'][$key];
            move_uploaded_file($_FILES['image']['tmp_name'][$key], "../upload/messages/" . $imgname);
            $images[] = $imgname;
        }
    }
    $rdispense->first_image = implode(',', $images);
    $etihad = [];
    if (isset($_FILES['etihadimg'])) {
        foreach ($_FILES['etihadimg']['name'] as $key => $val) {
            if ($_FILES['etihadimg']['tmp_name'][$key] != "") {
                $etihadName = time() . "_" . rand(100, 999) . "_" . $_FILES['etihadimg']['name'][$key];
                move_uploaded_file($_FILES['etihadimg']['tmp_name'][$key], "../upload/messages/" . $etihadName);
                $etihad[] = $etihadName;
            }
        }
    }
    $rdispense->sec_image = implode(',', $etihad);
    $ids = [];
    if (isset($_FILES['idimg'])) {
        foreach ($_FILES['idimg']['name'] as $key => $val) {
            if ($_FILES['idimg']['tmp_name'][$key] != "") {
                $idName = time() . "_" . rand(100, 999) . "_" . $_FILES['idimg']['name'][$key];
                move_uploaded_file($_FILES['idimg']['tmp_name'][$key], "../upload/messages/" . $idName);
                $ids[] = $idName;
            }
        }
    }
    $rdispense->therd_image = implode(',', $ids);
    
    $rdispense->sys_date = date("Y-m-d H:i:s");
    $rdispense->userid = $_SESSION['userid'];
    $rdispense->isdel = 0;
    
    $id = R::store($rdispense);
    return $id;
}

function update() {

    $id = $_POST['id'];
   $subject = $_POST['subject'];
    $details = $_POST['details'];
     $employee = "";
    if (isset($_POST['employee']) && is_array($_POST['employee'])) {
        $employee = implode(',', array_filter($_POST['employee']));
    }
   
    $rupdate = R::load('messages', $id);
    $rupdate->employee = $employee;
    $rupdate->subject = $subject;
    $rupdate->details = $details;
    function up($input, $old) {
        if (!empty($_FILES[$input]['name'][0])) {
            $files = [];
            foreach ($_FILES[$input]['name'] as $k => $v) {
                $n = time() . "_" . rand(111, 999) . "_" . $v;
                move_uploaded_file($_FILES[$input]['tmp_name'][$k], "../upload/messages/" . $n);
                $files[] = $n;
            }
            return implode(',', $files);
        }
        return $_POST[$old];
    }
    $rupdate->first_image   = up('image', 'imageurl');
    $rupdate->sec_image           = up('etihadimg', 'oldetihadimg');
    $rupdate->therd_image             = up('idimg', 'oldidimg');
    $rupdate->sys_date =  date("Y-m-d H:i:s");
    $rupdate->userid = $_SESSION['userid'];
    $rupdate->isdel = 0;
    
   
    $id = R::store($rupdate);
}

function deleteFinaly($id) { 
    
    $rupdates = R::load('messages', $id);
    
    if ($rupdates->id > 0) {
        $rupdates->isdel = 1;
        R::store($rupdates);
    }
}